<template>
  <div id="supermarkets">
    <v-container fluid>
      <v-row class="d-flex justify-center mt-5">
        <v-card class="mt-8 elevation-8 mx-auto mb-7" style="width: 90%">
          <v-card-title class="d-block text-center pt-6 pb-5 text-h4">
            Supermercati
          </v-card-title>
          <v-card-text>
            <v-data-table
                hide-default-footer
                :items="supermarkets"
                :headers="headers"
                item-key="item.id"
            >
              <template v-slot:top>
                <v-toolbar
                    flat
                >
                  <v-btn
                      color="primary"
                      dark
                      rounded
                      class="mb-2"
                      @click="dialog = true"
                  >
                    <v-icon small>fas fa-cart-plus</v-icon>
                  </v-btn>
                </v-toolbar>
              </template>
              <template v-slot:item.actions="{ item }">
                <v-icon
                    small
                    color="primary"
                    class="mx-2"
                    @click="editSupermarketPopup(item)"
                >
                  fas fa-edit
                </v-icon>
                <v-icon
                    small
                    color="primary"
                    class="mx-2"
                    @click="deleteSupermarket(item)"
                >
                  fas fa-trash
                </v-icon>
              </template>
            </v-data-table>
          </v-card-text>
        </v-card>
      </v-row>
    </v-container>

    <v-dialog
        v-model="dialog"
        width="50%"
        @click:outside="closeDialog"
        @close="closeDialog"
    >
      <v-card class="pt-10">
        <v-card-text>
          <v-text-field
              id="name"
              label="Nome"
              name="name"
              v-model="supermarket.name"
              outlined
              prepend-icon="far fa-store"
              type="text"
          ></v-text-field>
          <v-text-field
              id="latitudine"
              label="Latitudine"
              name="position.latitude"
              v-model="supermarket.position.latitude"
              outlined
              prepend-icon="fas fa-map-pin"
              type="text"
          ></v-text-field>
          <v-text-field
              label="Longitudine"
              name="position.longitude"
              type="longitude"
              v-model="supermarket.position.longitude"
              outlined
              prepend-icon="fas fa-map-pin"
          ></v-text-field>
        </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" @click="supermarketToEditId !== null ? editSupermarket() : createSupermarket()" >
          Salva
        </v-btn>
      </v-card-actions>
      </v-card>
    </v-dialog>
  </div>

</template>

<script>
export default {
  name: "Supermarkets",
  data() {
    return {
      headers: [
        {value: 'id', text: 'Id'},
        {value: 'name', text: 'Nome'},
        {value: 'position.latitude', text: 'Latitudine'},
        {value: 'position.longitude', text: 'Longitudine'},
        {text: 'Actions', value: 'actions', sortable: false}
      ],
      supermarkets: [],
      dialog: false,
      supermarket: {
        name: null,
        position: {
          latitude: null,
          longitude: null
        }
      },
      supermarketToEditId: null
    }
  },
  mounted() {
    this.getSupermarkets()
  },
  methods: {
    async getSupermarkets() {
      let response = await this.$http.get('/supermarkets');
      this.supermarkets = response.data;
    },

    async deleteSupermarket(item) {
      if (window.confirm("Sei sicuro di voler eliminare " + item.name + "?")) {
        await this.$http.delete('/supermarkets/' + item.id)
        await this.getSupermarkets()
      } else
        window.alert('Menomale, poverino!')

    },
    async editSupermarket() {
      try {
        await this.$http.put('/supermarkets/' + this.supermarketToEditId,  this.supermarket)
      } catch (error) {
        window.alert('Errore nella creazione!')
      } finally {
        await this.closeDialog()
      }
    },

    async createSupermarket() {
      try {
        await this.$http.post('/supermarkets', this.supermarket)
      } catch (error) {
        window.alert('Errore nella creazione del supermercato. \n Aprire la console per i dettagli')
        console.log(error)
      } finally {
        await this.closeDialog()
      }
    },

    editSupermarketPopup(item) {
      this.supermarket.name = item.name;
      this.supermarket.position.latitude = item.position.latitude;
      this.supermarket.position.longitude = item.position.longitude;
      this.supermarketToEditId = item.id;
      this.dialog = true;
    },
    async closeDialog() {
      this.resetSupermarket();
      this.dialog = false;
      await this.getSupermarkets();
    },
    resetSupermarket() {
      this.supermarket.name = null;
      this.supermarket.position.latitude = null;
      this.supermarket.position.longitude = null;
      this.supermarketToEditId = null
    }
  }
}
</script>



<style scoped>

</style>
